damageTables <- player_collection(player_collection(0));

::test <- false;

OnGameEvent("OnTakeDamage", 100, function(victim, params)
{
    if (params.damage > 1000)
        params.damage = 1000;
});

OnGameEvent("player_hurt", 100, function(victim, params)
{
    local attacker = GetPlayerFromParams(params, "attacker");
    if (attacker)
        damageTables[victim.entindex()][attacker.entindex()] += params.damageamount;
    else
        attacker = victim;

    if (victim.GetHealth() <= 0 && !test)
    {
        local assister = GetAssister(victim, attacker);
        if (attacker != victim)
        {
            if (assister != victim)
                victim.AddCondEx(TF_COND_URINE, 0, assister);

            local victimTeam = victim.GetTeam();
            SetPropInt(victim, "m_iTeamNum", 1);
            RunWithDelay(-1, function() {
                SetPropInt(self, "m_iTeamNum", victimTeam)
            }, victim)
        }
        else if (assister != victim)
        {
            victim.SetHealth(1100);
            local victimTeam = victim.GetTeam();
            RunWithDelay(-1, function() {
                victim.SetHealth(1);
                victim.TakeDamageEx(
                    null,
                    assister,
                    null,
                    Vector(),
                    Vector(),
                    100,
                    0);
                SetPropInt(self, "m_iTeamNum", victimTeam);
            }, victim)
        }
    }
})


OnGameEvent("player_death", 10, function(victim, params)
{
    local attacker = GetPlayerFromParams(params, "attacker");
    local assister = GetPlayerFromParams(params, "assister");

    if (attacker)
    {
        kills[attacker.entindex()]++;
        if (GetKills(attacker) % 2 == 0 || GetCurrentGunGameWeapon(attacker) == GetWeaponTypeByName("golden_crowbar"))
            attacker.GetScriptScope().SwitchToNextWeapon();
    }
    if (assister)
    {
        assists[assister.entindex()]++;
        if (GetAssists(assister) % 3 == 0 && GetCurrentGunGameWeapon(assister) != GetWeaponTypeByName("golden_crowbar"))
            assister.GetScriptScope().SwitchToNextWeapon();
    }
});

function GetAssister(victim, attacker)
{
    local assister = victim.entindex();
    attacker = attacker.entindex();
    local damage = 20;
    foreach(iAssister, iDamage in damageTables[victim.entindex()])
    {
        local iAssisterEnt = PlayerInstanceFromIndex(iAssister);
        if (iDamage > damage && iAssister != attacker && GetCurrentGunGameWeapon(iAssisterEnt) != GetWeaponTypeByName("golden_crowbar"))
        {
            assister = iAssister;
            damage = iDamage;
        }
    }
    return PlayerInstanceFromIndex(assister);
}

OnGameEvent("player_spawn", 0, function(player, params)
{
    damageTables[player.entindex()] = player_collection(0);
});

AddTimer(1, 0, function()
{
    foreach(damageTable in damageTables)
        foreach(player, damage in damageTable)
            if (damage > 0)
                damageTable[player] = damage - 5;
})