::game_text_top <- SpawnEntityFromTable("game_text",
{
    color = "236 227 203",
    color2 = "0 0 0",
    channel = 0,
    effect = 0,
    fadein = 0,
    fadeout = 0,
    fxtime = 0,
    holdtime = 250,
    message = "0asd",
    spawnflags = 0,
    x = -1,
    y = 0.07
});

::game_text_bottom <- SpawnEntityFromTable("game_text",
{
    color = "236 227 203",
    color2 = "0 0 0",
    channel = 1,
    effect = 0,
    fadein = 0,
    fadeout = 0,
    fxtime = 0,
    holdtime = 250,
    message = "0asd",
    spawnflags = 0,
    x = -1,
    y = 0.8
});

tf_player_manager.ValidateScriptScope();
tf_player_manager.GetScriptScope().ThinkScoreboard <- function()
{
    foreach (player in GetAllClients())
        SetPropIntArray(tf_player_manager, "m_iTotalScore", GetScore(player), player.entindex());
    return -1;
}
AddThinkToEnt(tf_player_manager, "ThinkScoreboard");
tf_player_manager.AddFlag(EFL_NO_THINK_FUNCTION);

AddTimer(-1, function()
{
    if (ended)
        return 0;
    local firstPlace = GetFirstPlace();
    local firstPlaceEnt = PlayerInstanceFromIndex(firstPlace[0]);
    local secondPlace = GetSecondPlace();
    local secondPlaceEnt = PlayerInstanceFromIndex(secondPlace[0]);
    foreach (player in GetAllClients())
    {
        if (!("currentWeapon" in player.GetScriptScope()))
            return;
        local res = "";
            res += GetPropString(firstPlaceEnt, "m_szNetname")+"  "+firstPlace[1].tointeger()+"   |   ";
        if (firstPlaceEnt != player)
            res += GetScore(player) + "  " + GetPropString(player, "m_szNetname");
        else
        {
            res += secondPlace[1].tointeger() +"  "+GetPropString(secondPlaceEnt, "m_szNetname");
        }
        res += "\nPlaying to∶ " + ((GUNGAME_ORDER.len() - 1) * 2 - 1)
        EntFireByHandle(game_text_top, "AddOutput", "message " + res, 0, player, player);
        EntFireByHandle(game_text_top, "Display", "", 0, player, player);

        if (GetCurrentGunGameWeapon(player) == GetWeaponTypeByName("golden_crowbar"))
        {
            res = "1 KILL UNTIL VICTORY"
        }
        else
        {
            res = "Next Weapon∶ " + GetNextGunGameWeapon(player).displayname
            res += "\n " + (2 - GetKills(player) % 2) + " more kills or"
            res += "\n " + (3 - GetAssists(player) % 3) + " more assists"
        }
        EntFireByHandle(game_text_bottom, "AddOutput", "message " + res, 0, player, player);
        EntFireByHandle(game_text_bottom, "Display", "", 0, player, player);
    }
});