::isFeedbackRound <- false;

::IsValidRound <- function()
{
    return !isFeedbackRound;
}

::OnFeedbackRound <- function()
{
    isFeedbackRound = true;
    foreach(player in GetAllClients())
    {
        player.SetCustomModelWithClassAnimations("");
        DeleteAllEventsFromScope(player);
        DeleteAllTimersFromScope(player);
        DeleteAllDelaysFromScope(player);
    }
    DeleteAllEventsFromScope(main_script);
    DeleteAllTimersFromScope(main_script);
    DeleteAllDelaysFromScope(main_script);
    main_script_entity.Kill();
}

local feedbackRelay = SpawnEntityFromTable("logic_relay", {
    targetname = "TF2M_FeedbackRoundRelay",
    spawnflags = 0,
    "OnTrigger": "!self,RunScriptCode,OnFeedbackRound(),0,-1",
});